Evaluation
==========

This is the code for evaluating QLever performance and correctness. It has two
general modes "completion" and "queries". In "completion" mode it simulates
constructin all queries in a given query list (in the same YAML format as used
by the QLever e2e tests) from an empty skeleton query ("SELECT ?var … ?varn
WHERE {}") using auto completion and counting the necesssary "typing".

In "queries" mode it takes the same query list YAML format but simply executes
the queries themselves.

Running with docker
------------------
To run with docker:

    docker build -t qlever-eval .
    docker run --rm -v $(pwd)/output:/output qlever-eval

Visualize the results of the evaluation
---------------------------------------
Make sure that the output directories are called output.<something> and that
they are in the same directory as this README.md. In that directory run

    python3 -m http.server <port>

A nice interactive web app visualizing the result will then be available under

    http://<host>:<port>/www

Running without docker
----------------------
To run without docker:

    virtualenv -p python3 venv
    source venv/bin/activate
    pip install -r requirements.txt

To test on galera with Wikidata Full and with QLever

    mkdir output-`date --iso`
    python eval.py completion --initial-clear-cache \
      --output-path output-`date --iso` \
      --backend http://galera.informatik.privat:7001 wikidata-full.queries.yml

To test on panarea with Blazegraph and Wikidata Full

    mkdir output-`date --iso`
    python eval.py completion --backend-type blazegraph \
      --output-path output-`date --iso` \
      --backend http://panarea.informatik.privat:9999/bigdata/sparql \
      wikidata-full-blaze.queries.yml

Regenerate SPARQL Parser from Grammar
-------------------------------------
The code for parsing SPARQL can be found in
[query\_model](/completion/query_model).
***Never modify any of the `SparqlXYZ.py` files by hand*** these are auto
generated from `Sparql.g4` using the following command:

    cd query_model
    antlr4 -Dlanguage=Python3 Sparql.g4 -visitor

The `-visitor` part is important because otherwise the parser does not call our
`visitXYZ()` methods. The `SparqlVisitor.py` file on the other hand can be
discarded, it's only a template.
