# SPARQL Autocompletion Evaluation

This is the README.md file explaining the results of the evaluation. There is
also a README.md file that explains
[how to run the evaluation and start this web app](https://github.com/ad-freiburg/qlever-evaluation/tree/master/evaluation-autocompletion).

## SPARQL Queries

We evaluate SPARQL queries on three knowledge bases: Freebase Easy, Freebase,
and Wikidata. Here are 
[the SPARQL queries](https://github.com/ad-freiburg/qlever-evaluation/tree/master/evaluation-autocompletion/queries-and-templates.wdqs).
for each knowledge base (it's the file that end with *queries.yml*).
To count the number of queries, just to Strg+F (find) for "sparql" when viewing
the file.
The SPARQL queries are derived from the example queries of the
[Wikidata Query Service](https://query.wikidata.org).

## Autocompletion Queries

For the evaluation, the body of the SPARQL queries are "typed" from left to
right, top to bottom. Each part of a triple is called a *token*. For each token,
an alias is selected at random from all (English) names and aliases provided
for that token in the knowledge base. To simulate the typing, a set of prefix
lengths is selected, for example: 0, 3, 7. For each prefix length, a completion
query is issued that returns suggestions for the token that start with a prefix
of the alias of that prefix length (for example, "bar" when we are search for
"Barack Obama" with prefix length 3).

Each completion query is again a SPARQL query and its result is a ranked list of
entities or predicates. The goal is twofold: to execute these queries as
efficiently as possible (nobody wants to wait long for suggestions) and to get
the desired token as high up in the list of results as possible.

A completion query can use the part of the SPARQL query already typed to deliver
better results. This process is controlled via *templates*. We have four kinds
of templates: sensitive (using the part of the SPARQL query already typed),
agnostic (ignoring that part), unranked (like agnostic but results are ranked
alphabetically), and mixed (try sensitive and when no result is obtained within
a timeout, take agnostic). The templates also depend on the position of a token
in a triple (subject, predicate, object) and on whether a prefix has already
been typed for a token.

The templates are specified in one file per knowledge base and kind. It's the
files called <kb>.completion-templates.<mode>... in
[this directory](https://github.com/ad-freiburg/qlever-evaluation/tree/master/evaluation-autocompletion/queries-and-templates.wdqs)
(the same directory, which also contains the full SPARQL queries).
